<?php
/************************************************************************
 * Mailer v0.2.1-FINAL                                Start: 06/25/2013 *
 * ===================                          Last change: 06/25/2013 *
 *                                                                      *
 * -------------------------------------------------------------------- *
 * File              : mode-update.php                                  *
 * -------------------------------------------------------------------- *
 * Short description : Clickable forced banner or text links            *
 * -------------------------------------------------------------------- *
 * Kurzbeschreibung  : Klickbare Forced-Banner oder -Textlinks          *
 * -------------------------------------------------------------------- *
 * Copyright (c) 2003 - 2009 by Roland Haeder                           *
 * Copyright (c) 2009 - 2013 by Mailer Developer Team                   *
 * For more information visit: http://mxchange.org                      *
 *                                                                      *
 * This program is free software; you can redistribute it and/or modify *
 * it under the terms of the GNU General Public License as published by *
 * the Free Software Foundation; either version 2 of the License, or    *
 * (at your option) any later version.                                  *
 *                                                                      *
 * This program is distributed in the hope that it will be useful,      *
 * but WITHOUT ANY WARRANTY; without even the implied warranty of       *
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the        *
 * GNU General Public License for more details.                         *
 *                                                                      *
 * You should have received a copy of the GNU General Public License    *
 * along with this program; if not, write to the Free Software          *
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston,               *
 * MA  02110-1301  USA                                                  *
 ************************************************************************/

// Some security stuff...
if (!defined('__SECURITY')) {
	die();
} // END - if

// @TODO Remove double tabs from all lines
		// Add dependency for ext-earning
		addExtensionDependency('earning');

		// All required tables for this extension:
		// - Ads
		addDropTableSql('forced_ads');
		addCreateTableSql('forced_ads', "
`forced_ads_id` BIGINT(20) UNSIGNED NOT NULL AUTO_INCREMENT,
`forced_ads_provider` ENUM('ADMIN', 'MEMBER', 'API', 'UNKNOWN') NOT NULL DEFAULT 'UNKNOWN',
`forced_ads_api_type` VARCHAR(255) NULL DEFAULT NULL,
`forced_ads_ad_url` VARCHAR(255) NULL DEFAULT NULL,
`forced_ads_click_url` VARCHAR(255) NOT NULL,
`forced_ads_width` SMALLINT(3) UNSIGNED NULL DEFAULT NULL,
`forced_ads_height` SMALLINT(3) UNSIGNED NULL DEFAULT NULL,
`forced_ads_alt_text` VARCHAR(255) NULL DEFAULT NULL,
`forced_ads_framebreaker` ENUM('Y','N') NOT NULL DEFAULT 'Y',
`forced_ads_type` VARCHAR(255) NOT NULL DEFAULT 'INVALID',
`forced_ads_views_counter` BIGINT(20) UNSIGNED NOT NULL DEFAULT 0,
`forced_ads_clicks_counter` BIGINT(20) UNSIGNED NOT NULL DEFAULT 0,
`forced_ads_added` TIMESTAMP NOT NULL DEFAULT CURRENT_TIMESTAMP,
`forced_ads_userid` BIGINT(20) UNSIGNED NULL DEFAULT NULL,
PRIMARY KEY (`forced_ads_id`),
INDEX (`forced_ads_userid`)",
			'Forced Ads Data');

		// - Connection -> ext-network
		addDropTableSql('forced_network');
		addCreateTableSql('forced_network', "
`forced_network_id` BIGINT(20) UNSIGNED NOT NULL AUTO_INCREMENT,
`forced_ads_id` BIGINT(20) UNSIGNED NOT NULL DEFAULT 0,
`network_type_id` BIGINT(20) UNSIGNED NOT NULL DEFAULT 0,
PRIMARY KEY (`forced_network_id`),
UNIQUE `ads_type` (`forced_ads_id`, `network_type_id`)",
			'Forced Campaign Data');

		// - Campaigns
		addDropTableSql('forced_campaigns');
		addCreateTableSql('forced_campaigns', "
`forced_campaign_id` BIGINT(20) UNSIGNED NOT NULL AUTO_INCREMENT,
`forced_campaign_created` TIMESTAMP NOT NULL DEFAULT CURRENT_TIMESTAMP,
`forced_campaign_status` ENUM('ACTIVE','PENDING','EXPIRED','LOCKED') NOT NULL DEFAULT 'PENDING',
`forced_campaign_last_locked` TIMESTAMP NULL DEFAULT NULL,
`forced_campaign_lock_reason` VARCHAR(255) NULL DEFAULT NULL,
`forced_campaign_expired` TIMESTAMP NULL DEFAULT NULL,
`forced_campaign_ordered_clicks` BIGINT(20) UNSIGNED NOT NULL DEFAULT 0,
`forced_campaign_payment_api` FLOAT(20,5) UNSIGNED NULL DEFAULT NULL,
`forced_campaign_reload_lock` BIGINT(20) UNSIGNED NOT NULL DEFAULT 0,
`forced_campaign_minimum_stay` BIGINT(20) UNSIGNED NOT NULL DEFAULT 0,
`forced_ads_id` BIGINT(20) UNSIGNED NOT NULL DEFAULT 0,
`forced_campaign_userid` BIGINT(20) UNSIGNED NULL DEFAULT NULL,
`forced_costs_id` BIGINT(20) UNSIGNED NULL DEFAULT NULL,
PRIMARY KEY (`forced_campaign_id`),
INDEX (`forced_costs_id`)",
			'Forced Campaign Data');

		// - Campaign costs
		addDropTableSql('forced_costs');
		addCreateTableSql('forced_costs', "
`forced_costs_id` BIGINT(20) UNSIGNED NOT NULL AUTO_INCREMENT,
`forced_costs_price_click` FLOAT(20,5) UNSIGNED NULL DEFAULT NULL,
`forced_costs_payment_click` FLOAT(20,5) UNSIGNED NULL DEFAULT NULL,
`forced_costs_visibility` ENUM('MEMBER','SPONSOR','ALL','NONE') NOT NULL DEFAULT 'NONE',
PRIMARY KEY (`forced_costs_id`)",
			'Forced Campaign Costs');

		// - Campaign Statistics
		addDropTableSql('forced_stats');
		addCreateTableSql('forced_stats', "
`forced_stats_id` BIGINT(20) UNSIGNED NOT NULL AUTO_INCREMENT,
`forced_stats_campaign_id` BIGINT(20) UNSIGNED NULL DEFAULT NULL,
`forced_stats_userid` BIGINT(20) UNSIGNED NULL DEFAULT NULL,
`forced_stats_token` VARCHAR(255) NULL DEFAULT NULL,
`forced_stats_viewed` TIMESTAMP NOT NULL DEFAULT CURRENT_TIMESTAMP,
`forced_stats_clicked` TIMESTAMP NULL DEFAULT NULL,
`forced_stats_real_ip` VARCHAR(15) NOT NULL DEFAULT '0.0.0.0',
`forced_stats_remote_addr` VARCHAR(15) NOT NULL DEFAULT '0.0.0.0',
`forced_stats_ua` VARCHAR(255) NULL DEFAULT NULL,
`forced_stats_is_proxy` ENUM('Y','N') NOT NULL DEFAULT 'N',
`forced_stats_session_id` VARCHAR(100) NULL DEFAULT NULL,
PRIMARY KEY (`forced_stats_id`),
INDEX (`forced_stats_campaign_id`),
INDEX (`forced_stats_userid`)",
			'Forced Campaign Statistics');

		// Menu system
		// - Administrator
		addAdminMenuSql('forced', NULL, 'Forced-Ads', 'Verwalten Sie hier bequem alle laufenden Forced-Banner, -Textlinks, -PopUps und deren Kampgnen. Sie k&ouml;nnen hier auch neue Werbmittel (Ads) hinzuf&uuml;gen oder laufende Forced-Kampagnen bei z.B. Regelverst&ouml;ssen sperren oder l&ouml;schen. Auch das natr&auml;gliche Editieren von Ads und Kampagnen ist jederzeit m&ouml;glich. Kampagnen dienen der einfacheren Verwaltung und der Trennung von dem Werbemittel selbst dienen. Sie brauchen also z.B. einen Forced-Banner nur einmal einf&uuml;gen und k&ouml;nnen dann bei Bedarf weitere Kampagnen starten.', 5);
		addAdminMenuSql('forced', 'list_forced_ads', 'Forced-Ads verwalten', 'Listet alle eingetragenen Forced-Ads (Werbmittel mit Klickzwang) auf und f&uuml;gt neue hinzu. Sie k&ouml;nnen hier diese nachtr&auml;glich editieren falls Sie mal eine falsche URL eingegeben haben oder den Text &auml;ndern wollen. L&ouml;schen Sie hier auch Forced-Banner, die nicht mehr g&uuml;ltig sind (z.B. abgelaufen sind). Sollten doch mit dem Werbmittel verkn&uuml;pfte Kampagnen vorhanden sein, erhalten Sie einen Warnhinweis. Neue Werbmittel k&ouml;nnen Sie hier ebenfalls hinzuf&uuml;gen. Denken Sie aber daran, dass ohne Kampagne dieses nicht angezeigt wird. Achten Sie hier auch die Reload-Sperre.', 2);
		addAdminMenuSql('forced', 'list_forced_campaigns', 'Kampagnen verwalten', 'Listet alle Kampagnen auf und zeigt deren Status an. Jederzeit k&ouml;nnen Sie Kampagnen stoppen, falls Sie dies w&uuml;nschen oder ein Regelverstoss vorliegt. Haben Sie ein Werbemittel hinzugef&uuml;gt, so f&uuml;gen Sie bitte unbedingt eine Kampagne hinzu, da es sonst nicht angezeigt wird.', 3);
		addAdminMenuSql('forced', 'list_forced_costs', 'Preise verwalten', 'Legen Sie die Preise pro Klick f&uuml;r Forced-Werbemittelbuchungen fest und wie viele {OPEN_CONFIG}POINTS{CLOSE_CONFIG} Ihre Mitglieder erhalten sollen. Generell sollten Sie bei Mitgliederbuchungen h&ouml;here Kosten pro Klick als was Ihre Mitglieder pro Klick erhalten einstellen, da so die {OPEN_CONFIG}POINTS{CLOSE_CONFIG} abgebaut werden (Sie k&ouml;nnen an Accountaufladungen z.B. verdienen).', 4);
		addAdminMenuSql('forced', 'stats_forced', 'Statistiken', 'Zeigt Gesamtstatistiken und zu den einzelnen Kampagnen und Werbmitteln an. Die hier angezeigte Statistik kann jedoch nicht manuell gel&ouml;scht werden (bitte auch nicht selber tun) da sie auch gleichzeitigt als Reload-Sperre dient.', 5);

		// - Members
		addMemberMenuSql('earn', 'forced_banner', 'Forced-Banner', 3);
		addMemberMenuSql('earn', 'forced_textlink', 'Forced-Textlinks', 4);
		addMemberMenuSql('extras', 'book_forced', 'Forced-Kampagne buchen', 3);

		// Register Forced-PopUps with earning_data table
		addExtensionSql("INSERT INTO `{?_MYSQL_PREFIX?}_earning_data` (`earning_group`, `earning_provider`, `earning_sorting`) VALUES ('POPUP','FORCED_POPUP',1)");

		// Register filters
		registerFilter(__FILE__, __LINE__, 'add_forced_ads_types', 'FORCED_AD_TYPE_DEFAULTS', FALSE, TRUE, isExtensionDryRun());
		registerFilter(__FILE__, __LINE__, 'member_earning_table_data', 'FORCED_POPUP_TABLE_DATA', FALSE, TRUE, isExtensionDryRun());
		registerFilter(__FILE__, __LINE__, 'post_change_forced_campaign_status', 'FORCED_CHANGE_CAMPAIGN_STATUS', FALSE, TRUE, isExtensionDryRun());
		registerFilter(__FILE__, __LINE__, 'pre_change_forced_campaign_status', 'FORCED_CHANGE_CAMPAIGN_VALIDATE_DATA', FALSE, TRUE, isExtensionDryRun());
		registerFilter(__FILE__, __LINE__, 'handle_click_php', 'HANDLE_FORCED_AD_CLICK', FALSE, TRUE, isExtensionDryRun());
		registerFilter(__FILE__, __LINE__, 'handle_view_php', 'HANDLE_FORCED_AD_VIEW', FALSE, TRUE, isExtensionDryRun());

// [EOF]
?>
