<?php
/************************************************************************
 * Mailer v0.2.1-FINAL                                Start: 06/29/2011 *
 * ===================                          Last change: 06/29/2011 *
 *                                                                      *
 * -------------------------------------------------------------------- *
 * File              : coupon_filter.php                                *
 * -------------------------------------------------------------------- *
 * Short description : Filters for ext-coupon                           *
 * -------------------------------------------------------------------- *
 * Kurzbeschreibung  : Filter fuer ext-coupon                           *
 * -------------------------------------------------------------------- *
 * $Revision::                                                        $ *
 * $Date::                                                            $ *
 * $Tag:: 0.2.1-FINAL                                                 $ *
 * $Author::                                                          $ *
 * -------------------------------------------------------------------- *
 * Copyright (c) 2003 - 2009 by Roland Haeder                           *
 * Copyright (c) 2009 - 2013 by Mailer Developer Team                   *
 * For more information visit: http://mxchange.org                      *
 *                                                                      *
 * This program is free software; you can redistribute it and/or modify *
 * it under the terms of the GNU General Public License as published by *
 * the Free Software Foundation; either version 2 of the License, or    *
 * (at your option) any later version.                                  *
 *                                                                      *
 * This program is distributed in the hope that it will be useful,      *
 * but WITHOUT ANY WARRANTY; without even the implied warranty of       *
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the        *
 * GNU General Public License for more details.                         *
 *                                                                      *
 * You should have received a copy of the GNU General Public License    *
 * along with this program; if not, write to the Free Software          *
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston,               *
 * MA  02110-1301  USA                                                  *
 ************************************************************************/

// Some security stuff...
if (!defined('__SECURITY')) {
	die();
} // END - if

// Filter to change column name for the right "points account"
function FILTER_COUPON_CHANGE_POINTS_COLUMN_NAME ($filterData) {
	//* DEBUG: */ logDebugMessage(__FUNCTION__, __LINE__, 'Called!');
	// Get the column name from extension's name and 'locked'
	$filterData['column'] = getPointsColumnNameFromSubjectLocked($filterData['subject'], $filterData['locked']);

	// Return data
	//* DEBUG: */ logDebugMessage(__FUNCTION__, __LINE__, 'Done!');
	return $filterData;
}

// Filter to do generic post-coupon-cash things
function FILTER_POST_CASH_COUPON ($filterData) {
	//* DEBUG: */ logDebugMessage(__FUNCTION__, __LINE__, 'Called!');
	// Now we just need to book that points on the user's account
	initReferralSystem();
	addPointsThroughReferralSystem('coupon_cashed', $filterData['userid'], $filterData['points']);

	// Subtract points from member account if the admin has selected one
	if (isValidId(getCouponUserid())) {
		// Subtract from this account and ignore return status
		subtractPoints('cashed_coupon', getCouponUserid(), $filterData['points']);
	} // END - if

	// Translate some data
	$filterData['coupon_expired'] = generateDateTime($filterData['coupon_expired'], '0');
	$filterData['coupon_created'] = generateDateTime($filterData['coupon_created'], '0');

	// Send admin notification
	sendAdminNotification('{--ADMIN_COUPON_CASHED_SUBJECT--}', 'admin_coupon_cashed', $filterData, $filterData['userid']);

	// Return data
	//* DEBUG: */ logDebugMessage(__FUNCTION__, __LINE__, 'Done!');
	return $filterData;
}

// [EOF]
?>
