<?php
/************************************************************************
 * Mailer v0.2.1-FINAL                                Start: 06/02/2011 *
 * ===================                          Last change: 06/02/2011 *
 *                                                                      *
 * -------------------------------------------------------------------- *
 * File              : _filter.php                                      *
 * -------------------------------------------------------------------- *
 * Short description : Filters for ext-                                 *
 * -------------------------------------------------------------------- *
 * Kurzbeschreibung  : Filter fuer ext-                                 *
 * -------------------------------------------------------------------- *
 * $Revision::                                                        $ *
 * $Date::                                                            $ *
 * $Tag:: 0.2.1-FINAL                                                 $ *
 * $Author::                                                          $ *
 * -------------------------------------------------------------------- *
 * Copyright (c) 2003 - 2009 by Roland Haeder                           *
 * Copyright (c) 2009 - 2013 by Mailer Developer Team                   *
 * For more information visit: http://mxchange.org                      *
 *                                                                      *
 * This program is free software; you can redistribute it and/or modify *
 * it under the terms of the GNU General Public License as published by *
 * the Free Software Foundation; either version 2 of the License, or    *
 * (at your option) any later version.                                  *
 *                                                                      *
 * This program is distributed in the hope that it will be useful,      *
 * but WITHOUT ANY WARRANTY; without even the implied warranty of       *
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the        *
 * GNU General Public License for more details.                         *
 *                                                                      *
 * You should have received a copy of the GNU General Public License    *
 * along with this program; if not, write to the Free Software          *
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston,               *
 * MA  02110-1301  USA                                                  *
 ************************************************************************/

// Some security stuff...
if (!defined('__SECURITY')) {
	die();
} // END - if

// Filter for updates/extends on the online list
function FILTER_UPDATE_ONLINE_LIST ($filterData) {
	// Do not update online list when extension is deactivated
	//* DEBUG: */ logDebugMessage(__FUNCTION__, __LINE__, 'Called!');
	if (!isExtensionActive('online')) {
		// Extension not active
		/* DEBUG: */ logDebugMessage(__FUNCTION__, __LINE__, 'Extension ext-online is not active.');
		return $filterData;
	} // END - if

	// Empty session?
	if (!isValidSession()) {
		// This is invalid here!
		reportBug(__FUNCTION__, __LINE__, 'Invalid session.');
	} // END - if

	// Initialize variables
	$userid   = NULL;
	$isMember = convertBooleanToYesNo(isMember());
	$isAdmin  = convertBooleanToYesNo(isAdmin());
	$action   = getActionFromModuleWhat(getModule(), getWhat(FALSE));

	// Valid userid?
	if (isMember()) {
		// Is valid user, so get the userid
		$userid = getMemberId();
	} // END - if

	// Now search for the user
	$result = sqlQueryEscaped("SELECT `timestamp` FROM `{?_MYSQL_PREFIX?}_online` WHERE `sid`='%s' LIMIT 1",
		array(session_id()), __FUNCTION__, __LINE__);

	// Entry found?
	if (sqlNumRows($result) == 1) {
		// Then update it
		sqlQueryEscaped("UPDATE
	`{?_MYSQL_PREFIX?}_online`
SET
	`module`='%s',
	`action`='%s',
	`what`='%s',
	`userid`=%s,
	`refid`=%s,
	`is_member`='%s',
	`is_admin`='%s',
	`timestamp`=UNIX_TIMESTAMP(),
	`ip`='%s'
WHERE
	`sid`='%s'
LIMIT 1",
		array(
			getModule(),
			$action,
			getWhat(FALSE),
			convertZeroToNull($userid),
			convertZeroToNull(determineReferralId()),
			$isMember,
			$isAdmin,
			detectRemoteAddr(),
			session_id()
		), __FUNCTION__, __LINE__);
	} else {
		// No entry does exists so we simply add it!
		sqlQueryEscaped("INSERT INTO `{?_MYSQL_PREFIX?}_online` (`module`, `action`, `what`, `userid`, `refid`, `is_member`, `is_admin`, `timestamp`, `sid`, `ip`) VALUES ('%s','%s','%s', %s, %s, '%s','%s', UNIX_TIMESTAMP(), '%s','%s')",
			array(
				getModule(),
				$action,
				getWhat(FALSE),
				convertZeroToNull($userid),
				convertZeroToNull(determineReferralId()),
				$isMember,
				$isAdmin,
				session_id(),
				detectRemoteAddr()
			), __FUNCTION__, __LINE__);
	}

	// Free result
	sqlFreeResult($result);

	// Purge old entries
	sqlQuery('DELETE LOW_PRIORITY FROM `{?_MYSQL_PREFIX?}_online` WHERE (UNIX_TIMESTAMP() - `timestamp`) >= {?online_timeout?}', __FUNCTION__, __LINE__);

	// Return data
	//* DEBUG: */ logDebugMessage(__FUNCTION__, __LINE__, 'Done!');
	return $filterData;
}

// [EOF]
?>
